Index: trunk/doc/manual/en_US/user_ThirdParty.xml
===================================================================
--- trunk/doc/manual/en_US/user_ThirdParty.xml	(revision 95825)
+++ trunk/doc/manual/en_US/user_ThirdParty.xml	(revision 95826)
@@ -1283,4 +1283,30 @@
           Copyright (c) 2017-2021 Philip Rebohle; Copyright (c)
           2019-2021 Joshua Ashton
+        </para>
+      </listitem>
+
+      <listitem>
+        <para>
+          &product-name; contains code from libtpms which is
+          governed by the license in
+          <xref linkend="licTpms" xrefstyle="template: %n" /> and
+        </para>
+
+        <para>
+          (c) Copyright IBM Corporation 2006 - 2011;
+          (c) Copyright IBM Corp. and others, 2012-2016
+        </para>
+      </listitem>
+
+      <listitem>
+        <para>
+          &product-name; contains code from libssh which is
+          governed by the license in
+          <xref linkend="licLGPL" xrefstyle="template: %n" /> and
+        </para>
+
+        <para>
+          Copyright (c) 2004-2013 by Aris Adamantiadis;
+          Copyright (c) 2009-2013 by Andreas Schneider &lt;asn@cryptomilk.org&gt;
         </para>
       </listitem>
@@ -11599,4 +11625,161 @@
     </sect2>
 
+    <sect2 id="licTpms">
+
+      <title>The IBM Corporation License for the libtpms library</title>
+
+      <para>
+        Copyright IBM Corporation 2006 - 2011 All rights reserved;
+        Copyright IBM Corp. and others, 2012-2016
+      </para>
+
+      <para>
+        For the TPM 1.2 code and the library code the following license applies:
+      </para>
+
+      <para>
+        Redistribution and use in source and binary forms, with or without
+        modification, are permitted provided that the following conditions are
+        met:
+        Redistributions of source code must retain the above copyright notice,
+        this list of conditions and the following disclaimer.
+        Redistributions in binary form must reproduce the above copyright
+        notice, this list of conditions and the following disclaimer in the
+        documentation and/or other materials provided with the distribution.
+        Neither the names of the IBM Corporation nor the names of its
+        contributors may be used to endorse or promote products derived from
+        this software without specific prior written permission.
+      </para>
+
+      <para>
+        THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
+        "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
+        LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
+        A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
+        HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+        SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+        LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+        DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+        THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+        (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
+        OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+      </para>
+
+      <para>
+        For the TPM 2 code the following license and notices apply:
+      </para>
+
+      <para>
+        Licenses and Notices
+      </para>
+
+      <orderedlist>
+
+      <listitem>
+
+        <para>
+          Copyright Licenses:
+        </para>
+
+        <itemizedlist>
+
+          <listitem>
+            <para>
+              Trusted Computing Group (TCG) grants to the user of the source code in
+              this specification (the "Source Code") a worldwide, irrevocable,
+              nonexclusive, royalty free, copyright license to reproduce, create
+              derivative works, distribute, display and perform the Source Code and
+              derivative works thereof, and to grant others the rights granted herein.
+            </para>
+          </listitem>
+
+          <listitem>
+            <para>
+              The TCG grants to the user of the other parts of the specification
+              (other than the Source Code) the rights to reproduce, distribute,
+              display, and perform the specification solely for the purpose of
+              developing products based on such documents.
+            </para>
+          </listitem>
+
+        </itemizedlist>
+
+      </listitem>
+
+      <listitem>
+        <para>
+          Source Code Distribution Conditions:
+        </para>
+
+        <itemizedlist>
+
+          <listitem>
+            <para>
+              Redistributions of Source Code must retain the above copyright licenses,
+              this list of conditions and the following disclaimers.
+            </para>
+          </listitem>
+
+          <listitem>
+            <para>
+              Redistributions in binary form must reproduce the above copyright
+              licenses, this list of conditions and the following disclaimers in the
+              documentation and/or other materials provided with the distribution.
+            </para>
+          </listitem>
+
+        </itemizedlist>
+
+      </listitem>
+
+      <listitem>
+        <para>
+          Disclaimers:
+        </para>
+
+        <itemizedlist>
+
+          <listitem>
+            <para>
+              THE COPYRIGHT LICENSES SET FORTH ABOVE DO NOT REPRESENT ANY FORM OF
+              LICENSE OR WAIVER, EXPRESS OR IMPLIED, BY ESTOPPEL OR OTHERWISE, WITH
+              RESPECT TO PATENT RIGHTS HELD BY TCG MEMBERS (OR OTHER THIRD PARTIES)
+              THAT MAY BE NECESSARY TO IMPLEMENT THIS SPECIFICATION OR OTHERWISE.
+              Contact TCG Administration (admin@trustedcomputinggroup.org) for
+              information on specification licensing rights available through TCG
+              membership agreements.
+            </para>
+          </listitem>
+
+          <listitem>
+            <para>
+              THIS SPECIFICATION IS PROVIDED "AS IS" WITH NO EXPRESS OR IMPLIED
+              WARRANTIES WHATSOEVER, INCLUDING ANY WARRANTY OF MERCHANTABILITY OR
+              FITNESS FOR A PARTICULAR PURPOSE, ACCURACY, COMPLETENESS, OR
+              NONINFRINGEMENT OF INTELLECTUAL PROPERTY RIGHTS, OR ANY WARRANTY
+              OTHERWISE ARISING OUT OF ANY PROPOSAL, SPECIFICATION OR SAMPLE.
+            </para>
+          </listitem>
+
+          <listitem>
+            <para>
+              Without limitation, TCG and its members and licensors disclaim all
+              liability, including liability for infringement of any proprietary
+              rights, relating to use of information in this specification and to the
+              implementation of this specification, and TCG disclaims all liability for
+              cost of procurement of substitute goods or services, lost profits, loss
+              of use, loss of data or any incidental, consequential, direct, indirect,
+              or special damages, whether under contract, tort, warranty or otherwise,
+              arising in any way out of use or reliance upon this specification or any
+              information herein.
+            </para>
+          </listitem>
+
+        </itemizedlist>
+      </listitem>
+    </orderedlist>
+
+    </sect2>
+
   </sect1>
 